//---------------------------------------------------------------------------

#include <vcl.h>
#include <jpeg.hpp>
#pragma hdrstop

#include "glowne.h"
#include "potomne.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormGlowne *FormGlowne;
//---------------------------------------------------------------------------
__fastcall TFormGlowne::TFormGlowne(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormGlowne::PlikWyjscieClick(TObject *Sender)
{
    this->Close();
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::PlikOtworzClick(TObject *Sender)
{
    if( this->OpenDialog1->Execute() )
    {
        TImage *pObrazekTmp = new TImage(NULL);
        pObrazekTmp->Picture->LoadFromFile(this->OpenDialog1->FileName);
        TFormPotomne* FormPotomek = new TFormPotomne(this);
        switch( pObrazekTmp->Picture->Bitmap->PixelFormat )
        {
            case pf24bit :
                FormPotomek->Image1->Picture = pObrazekTmp->Picture;
                break;
            default :
                delete FormPotomek;
                Application->MessageBox( "Nie obsuguj tego typu bitmapy.", "Usuwanie komponentu", MB_OK );
                return;
        }

        FormPotomek->Caption = ExtractFileName(this->OpenDialog1->FileName);
//        FormPotomek->Image1->Picture->LoadFromFile(this->OpenDialog1->FileName);
        FormPotomek->ClientWidth = FormPotomek->Image1->Picture->Bitmap->Width;
        FormPotomek->ClientHeight = FormPotomek->Image1->Picture->Bitmap->Height;

        delete pObrazekTmp;
        FormPotomek->Show();
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::RedukcjaSzaroscSredniaClick(TObject *Sender)
{
    TFormPotomne* AktualnyPotomek = (TFormPotomne *) ActiveMDIChild;

   // nie ma aktywnego okienka MDI
   if (AktualnyPotomek == NULL) return;

   TFormPotomne* FormPotomek = new TFormPotomne(this);
   FormPotomek->ClientWidth = AktualnyPotomek->ClientWidth;
   FormPotomek->ClientHeight = AktualnyPotomek->ClientHeight;
   FormPotomek->Caption = AktualnyPotomek->Caption + "[256 szary srednia]";
   FormPotomek->Image1->Picture = AktualnyPotomek->Image1->Picture;
   FormPotomek->RedukcjaSrednia();

   FormPotomek->Show();
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::RedukcjaSzaroscSrednia2Click(TObject *Sender)
{
   TFormPotomne* AktualnyPotomek = (TFormPotomne *) ActiveMDIChild;

   // nie ma aktywnego okienka MDI
   if (AktualnyPotomek == NULL) return;

   TFormPotomne* FormPotomek = new TFormPotomne(this);
   FormPotomek->ClientWidth = AktualnyPotomek->ClientWidth;
   FormPotomek->ClientHeight = AktualnyPotomek->ClientHeight;
   FormPotomek->Caption = AktualnyPotomek->Caption + "[256 szary wazona]";
   FormPotomek->Image1->Picture = AktualnyPotomek->Image1->Picture;
   FormPotomek->RedukcjaSredniaWazona();

   FormPotomek->Show();
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::Redukcja16RownomiernaClick(TObject *Sender)
{
   TFormPotomne* AktualnyPotomek = (TFormPotomne *) ActiveMDIChild;

   // nie ma aktywnego okienka MDI
   if (AktualnyPotomek == NULL) return;

   TFormPotomne* FormPotomek = new TFormPotomne(this);
   FormPotomek->ClientWidth = AktualnyPotomek->ClientWidth;
   FormPotomek->ClientHeight = AktualnyPotomek->ClientHeight;
   FormPotomek->Caption = AktualnyPotomek->Caption + "[16 rownomierna]";
   FormPotomek->Image1->Picture = AktualnyPotomek->Image1->Picture;
   FormPotomek->Redukcja16Rownomierna();

   FormPotomek->Show();
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::Redukcja16MedianaClick(TObject *Sender)
{
   TFormPotomne* AktualnyPotomek = (TFormPotomne *) ActiveMDIChild;

   // nie ma aktywnego okienka MDI
   if (AktualnyPotomek == NULL) return;

   TFormPotomne* FormPotomek = new TFormPotomne(this);
   FormPotomek->ClientWidth = AktualnyPotomek->ClientWidth;
   FormPotomek->ClientHeight = AktualnyPotomek->ClientHeight;
   FormPotomek->Caption = AktualnyPotomek->Caption + "[16 mediana]";
   FormPotomek->Image1->Picture = AktualnyPotomek->Image1->Picture;
   FormPotomek->Redukcja16Mediana();

   FormPotomek->Show();
}
//---------------------------------------------------------------------------

void __fastcall TFormGlowne::PlikZapiszClick(TObject *Sender)
{
   TFormPotomne* AktualnyPotomek = (TFormPotomne *) ActiveMDIChild;
   // nie ma aktywnego okienka MDI
   if (AktualnyPotomek == NULL) return;

   if( this->SaveDialog1->Execute() )
   {
        AktualnyPotomek->Image1->Picture->SaveToFile(this->SaveDialog1->FileName);
   }
}
//---------------------------------------------------------------------------

